#include "precomp.h"

IFACEMETHODIMP
CDSmartICE04DevicesEvents::GetConnectionInterface(IID* pIID)
{
    if(IsBadWritePtrT(pIID))
        return(E_POINTER);

    *pIID = DIID__DISmartICE04DevicesEvents;
    return(S_OK);
}

void
CDSmartICE04DevicesEvents::FireEvent(DISPID dispidEvt, IDispatch* TAG)
{
    DISPPARAMS  DispParams;
    VARIANT     var[2];

    VariantInit(&var[0]);
    VariantInit(&var[1]);
    V_DISPATCH(&var[0]) = TAG;
    V_DISPATCH(&var[0])->AddRef();
    V_VT(&var[0]) = VT_DISPATCH;
    m_pCPC->QueryInterface(IID_IDispatch, reinterpret_cast<void**>(&V_DISPATCH(&var[1])));
    V_VT(&var[1]) = VT_DISPATCH;

    DispParams.rgvarg               = var;
    DispParams.rgdispidNamedArgs    = nullptr;
    DispParams.cArgs                = _countof(var);
    DispParams.cNamedArgs           = 0;

    m_Connections.Enum([dispidEvt, &DispParams](const CONNECTDATA& cd) -> bool
    {
        static_cast<IDispatch*>(cd.pUnk)->Invoke(dispidEvt, IID_NULL, CThreadLocale::getLCID(), DISPATCH_METHOD, &DispParams, nullptr, nullptr, nullptr);
        return(true);
#pragma warning(suppress: 4820)
    });

    VariantClear(&var[0]);
    VariantClear(&var[1]);
}
