#include "precomp.h"

CDeferWindowPos::CDeferWindowPos(int nNumWindows)
    : m_hdwp(BeginDeferWindowPos(nNumWindows))
{
}

CDeferWindowPos::~CDeferWindowPos()
{
    if(m_hdwp)
        EndDeferWindowPos(m_hdwp);
}

BOOL
CDeferWindowPos::MoveWindow(HWND hWnd, int x, int y, int cx, int cy, BOOL blRepaint)
{
    const UINT uFlags = ((blRepaint) ? 0U : SWP_NOREDRAW) | SWP_NOOWNERZORDER | SWP_NOZORDER;

    if(m_hdwp)
        if(nullptr != (m_hdwp = DeferWindowPos(m_hdwp, hWnd, nullptr, x, y, cx, cy, uFlags)))
            return(TRUE);

    return(SetWindowPos(hWnd, nullptr, x, y, cx, cy, uFlags));
}
