#include "precomp.h"

HRESULT
CEventSink::ConnectTo(IUnknown* pUnk, REFIID riid)
{
    IConnectionPointContainer*  pCPC = nullptr;
    IConnectionPoint*           pCP = nullptr;
    HRESULT                     hr;

    if(FAILED(hr = pUnk->QueryInterface(IID_IConnectionPointContainer, reinterpret_cast<void**>(&pCPC))))
        return(hr);

    if(SUCCEEDED(hr = pCPC->FindConnectionPoint(riid, &pCP)))
    {
        DWORD dwCookie = 0;

        if(SUCCEEDED(hr = pCP->Advise(this, &dwCookie)))
        {
            Disconnect();
            m_dwCookie = dwCookie;
            m_pCP = pCP;
        }
        else
        {
            pCP->Release();
        }
    }

    pCPC->Release();
    return(hr);
}

HRESULT
CEventSink::Disconnect()
{
    HRESULT hr = S_FALSE;

    if(m_pCP)
    {
        if(m_dwCookie)
        {
            hr = m_pCP->Unadvise(m_dwCookie);
            m_dwCookie = 0;
        }
        m_pCP->Release();
        m_pCP = nullptr;
    }

    return(hr);
}
