#ifndef COLLECT_H_INCED
#define COLLECT_H_INCED

/*
 * Collect.h
 */

#include "Agdi.h"

#define nCFAMILY   8051              // identifies '8051 Target driver'


extern void       AnalyzeMonParas (char *pPath, char *pArgs);
extern void         WriteMonParams(char *pArgs, size_t cchMax);
extern char          MonErrBuffer[500];


union mamap {
  UL32      a32;
  U16       w16;
  UC8     ub[4];
};
#define MAMAP   union mamap

struct MonConf  {
    char        idDevice[32];
    unsigned    Opt;        // see monitor cache option definitions below.
};
extern struct MonConf MonConf;


// monitor cache options
#define CACHE_DATA     0x0001
#define CACHE_XDATA    0x0002
#define CACHE_CODE     0x0004

// Flash Download options
#define FLASH_ERASE    0x0100
#define FLASH_PROGRAM  0x0200
#define FLASH_VERIFY   0x0400

// Debug Adapter Options
#define DA_ASKUSER     0x1000
#define DA_SPECIFIC    0x2000


extern HWND          hMfrm;      // pointer to parent handle (CMainFrame)
extern struct dbgblk *pdbg;      // startup values


#define AG_ATR_UPTD   0x8000     // 'Up to date' Attribute
#define AG_ATR_WRPROT 0x1000     // Location is (software) write protected
#define AG_ATR_MOD    0x0080     // Location has been modified


#define  MSGM   (65536 + 4)
#define  ASGM   (MSGM * 2)

struct MMM  {
  UC8   *mem;                // Pointer to Memory Image
  U16   *atr;                // Pointer to Memory Attributes
};

#endif
