#ifndef CSMARTICE04DEVICES_H
#define CSMARTICE04DEVICES_H

class CSmartICE04Devices : public ISmartICE04Devices, public IConnectionPointContainer, public IProvideClassInfo2, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<ISmartICE04Devices*>(this)); }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid, hr)); }

public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IDispatch
    IFACEMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    IFACEMETHOD(GetTypeInfo)(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    IFACEMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    IFACEMETHOD(Invoke)(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04Devices
    IFACEMETHOD(get_Item)(const VARIANT varIndex, VARIANT* pVal);
    IFACEMETHOD(get_Count)(long* pVal);
    IFACEMETHOD(get_length)(long* pVal);
    IFACEMETHOD(get__NewEnum)(IUnknown** ppEnum);

    // IConnectionPointContainer
    IFACEMETHOD(EnumConnectionPoints)(IEnumConnectionPoints** ppEnum);
    IFACEMETHOD(FindConnectionPoint)(REFIID riid, IConnectionPoint** ppCP);

    // IProvideClassInfo2
    IFACEMETHOD(GetClassInfo)(ITypeInfo** ppTI);
    IFACEMETHOD(GetGUID)(DWORD dwGuidKind, GUID* pGUID);

    // ISupportErrorInfo
    IFACEMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

    static BOOL Cleanup();

    explicit CSmartICE04Devices(HRESULT* phr);

private:
    virtual ~CSmartICE04Devices();

    CSmartICE04Devices(const CSmartICE04Devices& other);
    CSmartICE04Devices& operator=(const CSmartICE04Devices& other);

    HRESULT Add(LPCTSTR pszName);
    HRESULT Add(const DEV_BROADCAST_DEVICEINTERFACE* pItf);
    HRESULT Remove(LPCTSTR pszName);
    HRESULT Remove(const DEV_BROADCAST_DEVICEINTERFACE* pItf);
    HRESULT getCount(long* pVal) const;
    void Refresh();

    static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    static ATOM m_ClassAtom;

    CList<class CSmartICE04*>   m_Devices;
    CDSmartICE04DevicesEvents   m_DispEvents;
    CSmartICE04DevicesEvents    m_Events;
    HDEVNOTIFY                  m_hDevNotify;
    ITypeInfo*                  m_pTypeInfo;
    ITypeLib*                   m_pTlb;
    HWND                        m_hWnd;
    volatile ULONG              m_lRefCount;
    BOOL                        m_blRefreshing;
};

#endif
