#ifndef CSMARTICE04DEVICESEVENTSSINK_H
#define CSMARTICE04DEVICESEVENTSSINK_H

class DECLSPEC_NOVTABLE CSmartICE04DevicesEventsSink : public ISmartICE04DevicesEvents, public CEventSink
{
public:
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    IFACEMETHOD(OnDeviceAttached)(IDispatch* sender, IDispatch* device);
    IFACEMETHOD(OnDeviceDetached)(IDispatch* sender, IDispatch* device);

    HRESULT Connect();
    HRESULT EnumDevices();

protected:
    IUnknown* GetUnknown() { return(static_cast<ISmartICE04DevicesEvents*>(this)); }

    virtual void AddDevice(ISmartICE04* pDevice) = 0;
    virtual void RemoveDevice(ISmartICE04* pDevice) = 0;

    CSmartICE04DevicesEventsSink() {}
    virtual ~CSmartICE04DevicesEventsSink() {}

private:
    explicit CSmartICE04DevicesEventsSink(const CSmartICE04DevicesEventsSink& other);
    CSmartICE04DevicesEventsSink& operator=(const CSmartICE04DevicesEventsSink& other);
};

template<typename T>
class CSmartICE04DevicesEventsSinkT : public CSmartICE04DevicesEventsSink
{
protected:
    void AddDevice(ISmartICE04* pDevice) override    { m_pParent->AddDevice(pDevice);    }
    void RemoveDevice(ISmartICE04* pDevice) override { m_pParent->RemoveDevice(pDevice); }

public:
    CSmartICE04DevicesEventsSinkT() : m_pParent(nullptr) {}

    void SetParent(T* pParent) { m_pParent = pParent; }

private:
    CSmartICE04DevicesEventsSinkT(const CSmartICE04DevicesEventsSinkT& other);
    CSmartICE04DevicesEventsSinkT& operator=(const CSmartICE04DevicesEventsSinkT& other);
    T* m_pParent;
};

#endif
