#ifndef CSMARTICE04EVENTSSINK_H
#define CSMARTICE04EVENTSSINK_H

class CSmartICE04EventsSink : public ISmartICE04Events, public CEventSink
{
protected:
    IUnknown* GetUnknown() { return(static_cast<ISmartICE04Events*>(this)); }
    virtual ~CSmartICE04EventsSink() {}

public:
    IFACEMETHOD(QueryInterface)(REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef)();
    IFACEMETHOD_(ULONG, Release)();

    IFACEMETHOD(OnTargetVoltageChanged)(IDispatch* sender, VARIANT_BOOL voltageDetected);
    IFACEMETHOD(OnTargetChanged)(IDispatch* sender, ChipId chipId);
    IFACEMETHOD(OnDebugModeChanged)(IDispatch* sender, VARIANT_BOOL isInDebugMode);

    HRESULT Connect(IUnknown* pUnk) { return(ConnectTo(pUnk, IID_ISmartICE04Events)); }
    HRESULT GetDevice(ISmartICE04** ppDevice);

    explicit CSmartICE04EventsSink(CDeviceList& deviceList) : m_DeviceList(deviceList) {}

private:
    CSmartICE04EventsSink(const CSmartICE04EventsSink& other);
    CSmartICE04EventsSink& operator=(const CSmartICE04EventsSink& other);

    CDeviceList& m_DeviceList;
};

#endif
