#ifndef CSMARTICE04PROGRESS_H
#define CSMARTICE04PROGRESS_H

class CSmartICE04Progress : public IDispatch, public ISmartICE04Progress, public ISupportErrorInfo
{
protected:
    inline IUnknown* GetUnknown() { return(static_cast<IDispatch*>(this)); }
    inline HRESULT RaiseCOMException(DISPID dispid, HRESULT hr) { return(::RaiseCOMException(this, dispid,hr)); }

public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IDispatch
    IFACEMETHOD(GetTypeInfoCount)(UINT* pctinfo);
    IFACEMETHOD(GetTypeInfo)(UINT iTInfo, LCID lcid, ITypeInfo** ppTInfo);
    IFACEMETHOD(GetIDsOfNames)(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId);
    IFACEMETHOD(Invoke)(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, UINT* puArgErr);

    // ISmartICE04Progress
    IFACEMETHOD(Start)();
    IFACEMETHOD(Stop)();
    IFACEMETHOD(SetProgress)(long lCompleted, long lTotal);
    IFACEMETHOD(get_Canceled)(VARIANT_BOOL* pblCanceled);

    // SupportErrorInfo
    IFACEMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

    CSmartICE04Progress(ITypeLib* pTlb, ISmartICE04ProgressDialog* pDlg, HWND hWndParent, HRESULT* phr);

private:
    virtual ~CSmartICE04Progress();

    void EnableParent() const;
    void DisableParent() const;

    static void PreventPinning(HWND hWnd, BOOL enable);
    static INT_PTR CALLBACK DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
    static DWORD WINAPI ThreadProc(LPVOID lpParameter);
    static LRESULT CALLBACK SubClassProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

    enum Flags
    {
        FLAG_PARENTENABLED = 1U,
        FLAG_PROPERTYVALID = 2U
    };

    static const TCHAR  m_szSmartICE04Progress[];
    volatile HWND       m_hWnd;
    ITaskbarList3*      m_pTaskbarList;
    ITypeInfo*          m_pTypeInfo;
    ITypeInfo*          m_pDispTypeInfo;
    WNDPROC             m_wndproc;
    HWND                m_hWndParent;
    volatile ULONG      m_lRefCount;
    UINT                m_uFlags;
};

#endif
