#include "precomp.h"

CThreadDpiAwarenessContext::CThreadDpiAwarenessContext(DPI_AWARENESS_CONTEXT dpiContext)
    : m_pfn(nullptr), m_ctx(nullptr)
{
    HINSTANCE hUser = GetModuleHandle(TEXT("user32.dll"));

    if(hUser)
    {
#pragma warning(suppress: 4191)
        m_pfn = reinterpret_cast<SETTHREADDPIAWARENESSCONTEXT>(GetProcAddress(hUser, "SetThreadDpiAwarenessContext"));

        if(m_pfn)
            m_ctx = m_pfn(dpiContext);
    }
}

CThreadDpiAwarenessContext::~CThreadDpiAwarenessContext()
{
    if(m_ctx)
        m_pfn(m_ctx);
}
