#ifndef CTHREADDPIAWARENESSCONTEXT_H
#define CTHREADDPIAWARENESSCONTEXT_H

#ifndef WM_DPICHANGED
#define WM_DPICHANGED                   0x02E0
#endif

#ifndef WM_DPICHANGED_BEFOREPARENT
#define WM_DPICHANGED_BEFOREPARENT      0x02E2
#endif

#ifndef WM_DPICHANGED_AFTERPARENT
#define WM_DPICHANGED_AFTERPARENT       0x02E3
#endif

#ifndef _DPI_AWARENESS_CONTEXTS_
#define _DPI_AWARENESS_CONTEXTS_

DECLARE_HANDLE(DPI_AWARENESS_CONTEXT);

#define DPI_AWARENESS_CONTEXT_UNAWARE              ((DPI_AWARENESS_CONTEXT)-1)
#define DPI_AWARENESS_CONTEXT_SYSTEM_AWARE         ((DPI_AWARENESS_CONTEXT)-2)
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE    ((DPI_AWARENESS_CONTEXT)-3)

#ifndef DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2
#define DPI_AWARENESS_CONTEXT_PER_MONITOR_AWARE_V2 ((DPI_AWARENESS_CONTEXT)-4)
#endif

#endif

class CThreadDpiAwarenessContext
{
public:
    explicit CThreadDpiAwarenessContext(DPI_AWARENESS_CONTEXT dpiContext);
    ~CThreadDpiAwarenessContext();

private:
    CThreadDpiAwarenessContext(const CThreadDpiAwarenessContext& other);
    CThreadDpiAwarenessContext& operator=(const CThreadDpiAwarenessContext& other);

    typedef DPI_AWARENESS_CONTEXT (WINAPI * SETTHREADDPIAWARENESSCONTEXT)(DPI_AWARENESS_CONTEXT dpiContext);

    SETTHREADDPIAWARENESSCONTEXT    m_pfn;
    DPI_AWARENESS_CONTEXT           m_ctx;
};

#endif
