#ifndef CTHREADLOCALE_H
#define CTHREADLOCALE_H

class CThreadLocale
{
public:
    explicit CThreadLocale(LCID lcid) : m_lcid(GetThreadLocale()) { SetThreadLocale(lcid); }
    ~CThreadLocale() { SetThreadLocale(m_lcid); }

    static inline LCID    getLCID()   { return(GetThreadLocale());          }
    static inline LANGID  getLANGID() { return(LANGIDFROMLCID(getLCID()));  }

private:
    LCID m_lcid;
};

class CCrtLocale
{
public:
    CCrtLocale(int category, const TCHAR* locale) { if(nullptr != (m_pPrevLocale = _tcsdup(_tsetlocale(LC_ALL, nullptr)))) _tsetlocale(category, locale); }
    ~CCrtLocale() { if(m_pPrevLocale) { _tsetlocale(LC_ALL, m_pPrevLocale); free(m_pPrevLocale); }}

private:
    CCrtLocale(const CCrtLocale& other);
    CCrtLocale& operator=(const CCrtLocale& other);

    PTSTR m_pPrevLocale;
};

#endif
