#include "precomp.h"

static volatile ULONG_PTR gs_lLockCount;

BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason, LPVOID lpReserved)
{
    switch(fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            g_hInst = hinstDll;
#ifdef _DLL
            DisableThreadLibraryCalls(g_hInst);
#endif
            break;
        case DLL_PROCESS_DETACH:
            if(!lpReserved)
                CSmartICE04Devices::Cleanup();

            break;
        default:
            break;
    }

    return(TRUE);
}

ULONG_PTR LockServer()
{
    return(InterlockedIncrement(&gs_lLockCount));
}

ULONG_PTR UnlockServer()
{
    return(InterlockedDecrement(&gs_lLockCount));
}

STDAPI DllCanUnloadNow()
{
    return((gs_lLockCount) ? S_FALSE : S_OK);
}

#pragma warning(push)
#pragma warning(disable: 6387)
__checkReturn STDAPI DllGetClassObject(__in REFCLSID rclsid, __in REFIID riid, __deref_out LPVOID* ppv)
{
    IClassFactory* pcf;

    if(IsBadWritePtrT(ppv))
        return(E_POINTER);

    *ppv = nullptr;

    if(IsBadReadPtrT(&rclsid))
        return(E_INVALIDARG);

    if(IsEqualCLSID(rclsid, CLSID_SmartICE04Devices))
        pcf = new (std::nothrow) CClassFactoryT<CSmartICE04Devices>;
    else if(IsEqualCLSID(rclsid, CLSID_SmartICE04ProgressDialog))
        pcf = new (std::nothrow) CClassFactoryT<CSmartICE04ProgressDialog>;
    else
        return(CLASS_E_CLASSNOTAVAILABLE);

    if(!pcf)
        return(E_OUTOFMEMORY);

    const HRESULT hr = pcf->QueryInterface(riid, ppv);
    pcf->Release();
    return(hr);
}
#pragma warning(pop)
