#include "precomp.h"

int
CMainDialog::DoModal(HWND hWndParent)
{
    CMainDialog dlg;
    return(static_cast<int>(DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_MAIN), hWndParent, DlgProc, reinterpret_cast<LPARAM>(&dlg))));
}

INT_PTR
CMainDialog::OnWmCommand(HWND hWnd, WPARAM wParam, LPARAM)
{
    switch(LOWORD(wParam))
    {
        case IDOK:
            ShowWindow(hWnd, SW_HIDE);

            if(IsDlgButtonChecked(hWnd, IDC_PROG_SMARTRF04EB) == BST_CHECKED)
                CSmartRF04EBDialog::DoModal(hWnd);
            else
                CSmartICE04Dialog::DoModal(hWnd);

        case IDCANCEL:
            EndDialog(hWnd, 0);
            return(TRUE);
        default:
            break;
    }

    return(FALSE);
}

INT_PTR
CMainDialog::OnWmInitDialog(HWND hWnd, WPARAM, LPARAM)
{
    CheckRadioButton(hWnd, IDC_PROG_SMARTRF04EB, IDC_PROG_SMARTICE04, IDC_PROG_SMARTICE04);
    return(TRUE);
}

INT_PTR CALLBACK
CMainDialog::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static const DLG_MSGMAP<CMainDialog> sc_map[] =
    {
        { WM_COMMAND,   &CMainDialog::OnWmCommand   }
    };

    for(uintptr_t x = 0; x < _countof(sc_map); ++x)
    {
        if(sc_map[x].uMsg == uMsg)
        {
            CMainDialog* pThis = reinterpret_cast<CMainDialog*>(GetWindowLongPtr(hWnd, DWLP_USER));

            if(pThis)
                return((pThis->*sc_map[x].pfn)(hWnd, wParam, lParam));
        }
    }

    if(uMsg == WM_INITDIALOG)
    {
        SetWindowLongPtr(hWnd, DWLP_USER, lParam);
        return reinterpret_cast<CMainDialog*>(lParam)->OnWmInitDialog(hWnd, wParam, lParam);
    }

    return FALSE;
}
