#ifndef CSIUTIL_H
#define CSIUTIL_H

class DECLSPEC_NOVTABLE CSiUtil
{
protected:
    CSiUtil() {}

public:
    virtual ~CSiUtil() {}

    virtual HRESULT Connect() = 0;
    virtual HRESULT Disconnect() = 0;
    virtual HRESULT Download(char* pDownloadFile, BOOL bDeviceErase);
    virtual HRESULT GetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    virtual HRESULT SetCodeMemory(BYTE* ptrMem, DWORD wStartAddress, unsigned int nLength);
    virtual HRESULT SetTargetGo();
    virtual HRESULT SetAppName(const char* pName);

    virtual bool operator==(const char* sernum) = 0;
};

class CSiUtilEC2 : public CSiUtil
{
public:
    explicit CSiUtilEC2(int nCommPort);
    virtual ~CSiUtilEC2();

    HRESULT Connect() override;
    HRESULT Disconnect() override;
    bool operator==(const char* sernum) override;

private:
    int m_nCommPort;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

class CSiUtilEC3 : public CSiUtil
{
public:
    explicit CSiUtilEC3(const char* pSerNum);
    virtual ~CSiUtilEC3();

    HRESULT Connect() override;
    HRESULT Disconnect() override;
    bool operator==(const char* sernum) override;

private:
    char* m_pSerNum;
};

#endif
