#include "precomp.h"

class CCoInitialize
{
public:
    explicit CCoInitialize(DWORD dwCoInit) : m_hr(CoInitializeEx(nullptr, dwCoInit | COINIT_DISABLE_OLE1DDE)) { assert(SUCCEEDED(m_hr)); }
    ~CCoInitialize() { if(SUCCEEDED(m_hr)) CoUninitialize(); }

    operator HRESULT() const { return(m_hr); }

private:
    CCoInitialize(const CCoInitialize& other);
    CCoInitialize& operator=(const CCoInitialize& other);

    const HRESULT m_hr;
};

static BOOL InitControls()
{
    INITCOMMONCONTROLSEX iccex;
    iccex.dwSize = sizeof(iccex);
    iccex.dwICC = ICC_STANDARD_CLASSES | ICC_USEREX_CLASSES;
    return(InitCommonControlsEx(&iccex));
}

EXTERN_C int WINAPI _tWinMain(__in HINSTANCE hInstance, __in_opt HINSTANCE, __in LPTSTR, __in int)
{
#ifndef _DEBUG
    HeapSetInformation(nullptr, HeapEnableTerminationOnCorruption, nullptr, 0);
#else
    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_DELAY_FREE_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
#endif

    CCoInitialize coinit(COINIT_APARTMENTTHREADED);
    g_hInst = hInstance;
    DpiAwarenessHelper::InitializeDpiAwarenessHelper();
    InitControls();
    return(CMainDialog::DoModal(nullptr));
}
